<?php

//=========================================================================

//

// WD Clientraw Datafile Extraction Routines

//

// Written by: Kevin Reed <tnet.services@gmail.com>

// http://www.tnet.com/weather

//

// Purpose:

//

// These will read using PHP the three possible clientraw datafiles

// from a local or remote location and allow the user to parse out

// the various data elements they want.

//

//=========================================================================

//

// Functions

//

//=========================================================================

// You may not have this... just comment out if you don't

//$PHPCOUNTER = $_SERVER['DOCUMENT_ROOT']."/cgi/phpcounter/counter.php";



// Function get_raw

// This function reads the file pointed at by $rawfile and extracts the

// data by returning an array of what it found. If it found nothing

// it returns -9999 in the first element of the returned array.

//



function get_raw( $rawfile ) {

$rawdata = array();

$fd = fopen($rawfile, "r");

if ($fd) {

$rawcontents = '';

while (! feof ($fd) ) {

$rawcontents .= fread($fd, 8192);

}

fclose($fd);

$delimiter = " ";

$rawdata = explode ($delimiter, $rawcontents);

} else {

$rawdata[0]= -9999;

}

return $rawdata;

}



//=========================================================================

//

// Start of Main Module

//

//=========================================================================



$hostloc = "../";

$clientraw = get_raw("${hostloc}clientraw.txt");

$clientrawextra = get_raw("${hostloc}clientrawextra.txt");

//$clientrawdaily = get_raw ("${hostloc}clientrawdaily.txt");



$location = $clientraw[32];

	$location      = str_replace('_',' ',$location);

	$location      = str_replace('-',' ',$location);



//=========================================================================

//

//    From this point I use some of the code written by 

//

//     Anole Computer Services, LLC

//

// from  the sticker-script found at http://anolecomputer.com

//

//

//=========================================================================





//temp convertion

$temp = $clientraw[4];

$temp_hi = $clientraw[46];

$temp_lo = $clientraw[47];



$temp_prec = '2';



      $temp_f = sprintf("%01.1f",CtoF($temp, $temp_prec));

      $temp_hi_f = sprintf("%01.1f",CtoF($temp_hi, $temp_prec));

      $temp_lo_f = sprintf("%01.1f",CtoF($temp_lo, $temp_prec));



//windconvertion

$windspeed = $clientraw[1];

$windgust = $clientraw[2];

$winddir = $clientraw[3];

$maxwindgust = $clientraw[133];



$wind_prec = '1';



      $wind_kmh = sprintf("%01.1f",KTStoKPH($windspeed, $wind_prec));

      $windgust_kmh = sprintf("%01.1f",KTStoKPH($windgust, $wind_prec));

      $wind_mph = sprintf("%01.1f",KTStoMPH($windspeed, $wind_prec));

      $windgust_mph = sprintf("%01.1f",KTStoMPH($windgust, $wind_prec));

      $wind_mps = sprintf("%01.1f",KTStoMPS($windspeed, $wind_prec));

      $windgust_mps = sprintf("%01.1f",KTStoMPS($windgust, $wind_prec));

      $maxwindgust_kmh = sprintf("%01.1f",KTStoKPH($maxwindgust, $wind_prec));

      $maxwindgust_mph = sprintf("%01.1f",KTStoMPH($maxwindgust, $wind_prec));



//pressureconvertion

$baro = $clientraw[6];

$baro_change = $clientraw[50];

$baro_hi = $clientraw[131];

$baro_lo = $clientraw[132];



$barom_prec = '2';

      $baro_inch = sprintf("%01.2f",MBtoINCHES($baro, $barom_prec));

      $baro_change_inch = sprintf("%01.2f",MBtoINCHES($baro_change, $barom_prec));

      $baro_hi_inch = sprintf("%01.2f",MBtoINCHES($baro_hi, $barom_prec));

      $baro_lo_inch = sprintf("%01.2f",MBtoINCHES($baro_lo, $barom_prec));



//rainconvertion

$rain_today = $clientraw[7];

$rain_yesterday = $clientrawextra[534];

$rain_month = $clientraw[8];

$rain_year = $clientraw[9];



$rain_prec = '3';

      $rain_today_inch = sprintf("%01.2f",MMtoINCHES($rain_today, $rain_prec));

      $rain_yesterday_inch = sprintf("%01.2f",MMtoINCHES($rain_yesterday, $rain_prec));

      $rain_month_inch = sprintf("%01.2f",MMtoINCHES($rain_month, $rain_prec));

      $rain_year_inch = sprintf("%01.2f",MMtoINCHES($rain_year, $rain_prec));



  // figure out a text value for compass direction

   switch (TRUE) {

     case (($winddir >= 349) and ($winddir <= 360)):

       $winddir = 'N';

     break;

     case (($winddir >= 0) and ($winddir <= 11)):

       $winddir = 'N';

     break;

     case (($winddir > 11) and ($winddir <= 34)):

       $winddir = 'NNE';

     break;

     case (($winddir > 34) and ($winddir <= 56)):

       $winddir = 'NE';

     break;

     case (($winddir > 56) and ($winddir <= 78)):

       $winddir = 'ENE';

     break;

     case (($winddir > 78) and ($winddir <= 101)):

       $winddir = 'E';

     break;

     case (($winddir > 101) and ($winddir <= 124)):

       $winddir = 'ESE';

     break;

     case (($winddir > 124) and ($winddir <= 146)):

       $winddir = 'SE';

     break;

     case (($winddir > 146) and ($winddir <= 169)):

       $winddir = 'SSE';

     break;

     case (($winddir > 169) and ($winddir <= 191)):

       $winddir = 'S';

     break;

     case (($winddir > 191) and ($winddir <= 214)):

       $winddir = 'SSW';

     break;

     case (($winddir > 214) and ($winddir <= 236)):

       $winddir = 'SW';

     break;

     case (($winddir > 236) and ($winddir <= 259)):

       $winddir = 'WSW';

     break;

     case (($winddir > 259) and ($winddir <= 281)):

       $winddir = 'W';

     break;

     case (($winddir > 281) and ($winddir <= 304)):

       $winddir = 'WNW';

     break;

     case (($winddir > 304) and ($winddir <= 326)):

       $winddir = 'NW';

     break;

     case (($winddir > 326) and ($winddir <= 349)):

       $winddir = 'NNW';

     break;

     case (($winddir > 360)):

       $winddir = '';

     break;



   } // end switch



// KTStoKPH: converts KTS to KPH

function KTStoKPH($value, $precision) {

  global $wind_prec;

  return round($value = (1.852 * $value),$precision);

} // end function KTStoKPH



// KTStoMPH: converts KTS to MPH

function KTStoMPH($value, $precision) {

  global $wind_prec;

  return round($value = (1.1507794 * $value),$precision);

} // end function KTStoMPH



// KTStoMPS: converts KTS to MPS

function KTStoMPS($value, $precision) {

  global $wind_prec;

  return round($value = (1.9438445 * $value),$precision);

} // end function KTStoMPS



// MBtoINCHES: converts mb to in/Hg

function MBtoINCHES($value, $precision) {

  global $barom_prec;

  return round($value = ($value / 33.86388158),$precision);

} // end function MBtoINCHES



// CtoF: converts degrees Celcius to degress Farenheight

function CtoF($value, $precision) {

  global $temp_prec;

  return round($value = ((1.8* $value) + 32),$precision);

} // end function C_to_F



// MMtoINCHES: converts mm to inches

function MMtoINCHES($value, $precision) {

  global $rain_prec;

  return round($value = (.0393700787 * $value),$precision);

} // end function MMtoINCHES

include 'winddir.php';

$year = date(" Y",time());

//=========================================================

//

//         EDIT THESE

//

//=========================================================

$yourcopyright = 'Your website';

$mail = 'nobody@nowhere.com';



?>
